// GR8BIT front panel cartridge slot to dual 5-1/4" drive bay adapter

// drive bay mount

//function inch2mm(i) = (i*25.4);


faceToA = 52;
AToB = 79;
layer1 = 9;
layer2 = 21;
fullh = 83;
fullhl2 = 43;

holesize = 4;
rinfd = 11;
rinfi = 1.2;

pcbrear = 41.6;

module CaseHole(x,z) {
  translate([x,0,z])
  rotate([90,0,0])
  union() {
    cylinder(h=300,d=holesize,center=true,$fn=12);
    //cylinder(h=rinfi,d=rinfd,center=true);
  }
}

module MountHole(x,z) {
  translate([x,0,z])
  rotate([-90,0,0])
  union() {
    cylinder(h=300,d=holesize,center=true,$fn=12);
    translate([0,0,2])
    cylinder(h=2,d=holesize+3,center=true);
  }
}


module PcbSupportTop() {    
  // 13.5 mm from 0, for pcb hole  
  
  scale([1,-1,1])
  difference() {
    union() {
      cube([4,25,36]);  
    
      linear_extrude(height = 36, center = false, convexity = 10, twist = 0)
      polygon([[0,0],[0,20],[4,20],[40,0]]);
    }

    translate([0,6,9])
    rotate([90,0,90])
    cylinder(h=300,d=holesize,center=true,$fn=12);
      
    translate([4,1,3])
    cube([40,60,30]);
  }
}

module PcbSupportBottom() {    
  // 13.5 mm from 0, for pcb hole  
  scale([1,-1,1])
  difference() {
    union() {
      cube([4,25,36]);  
    
      linear_extrude(height = 36, center = false, convexity = 10, twist = 0)
      polygon([[0,0],[0,20],[4,20],[40,0]]);
    }

    translate([0,6,14])
    rotate([90,0,90])
    cylinder(h=300,d=holesize,center=true,$fn=12);
      
    translate([4,1,3])
    cube([40,60,30]);
  }
}

difference() {
  union() {
    cube([faceToA+AToB+10, 2, fullh]);

    translate([pcbrear,0,0])
    PcbSupportBottom();
      
    translate([pcbrear,0,46])
    PcbSupportTop();
    
    translate([110,-1,70])
    rotate([90,0,0])  
    linear_extrude(1)  
    text("L");
  }

  //-- bottom half
  CaseHole(faceToA,layer1);  

  CaseHole(faceToA+AToB,layer1);

  CaseHole(faceToA,layer2);

  CaseHole(faceToA+AToB,layer2);
  
  //-- top half
  CaseHole(faceToA,layer1+fullhl2);

  CaseHole(faceToA+AToB,layer1+fullhl2);

  CaseHole(faceToA,layer2+fullhl2);

  CaseHole(faceToA+AToB,layer2+fullhl2);
  
  //-- half height separation
  translate([faceToA+10-30,0,fullhl2-5])
  cube([AToB+30,4,5]);
  
  //-- mount holes for front panel
  MountHole(6,7);
  MountHole(6,fullh-6);
}

