// GR8BIT front panel cartridge slot to dual 5-1/4" drive bay adapter

//function inch2mm(i) = (i*25.4);

// internal drive bay width (?142 or 146?)
dbw=146;

// front panel dimensions
fx=150;
fy=86;

// cartridge hole max inset
cinsert=42;
cx=111;
cy=20;

module SideMount() {
  difference() {
    union() {
      cube([3,12,12]);
      
      translate([0,10,0])
      cube([8,2,12]);
    }
 
    translate([0,6,6])
    rotate([90,0,90])
    cylinder(h=20,d=4,center=true,$fn=12); 
    
    translate([12,10,0])
    rotate([0,-45,0])
    cube([12,2,12.7]);
    
    translate([3,10,9])
    cube([12,2,12]);    
  }
}

module SwitchHold() {
  sx=6.5;
  sy=6.2;
  sz=13.2;
    
  cube([sx+1,sy+1,1]);

  translate([0,0,sz+1])
  cube([1.75,sy+1,1]);
  
  cube([1,sy+1,sz+1]);

  translate([sx+0.5,0,sz/2 - 0.5])    
  cube([1,sy,3]);
    
  translate([sx-0.5,sy,sz/2 - 0.5])    
  cube([2,1,3]);
}

module SwitchCutout() {
  union() {
    cube([6,2,11]);
    
    translate([0,0.8,-0.5])
    cube([6,2,13]);  
      
    translate([1.5/2,0,0])
    cube([4.5,2,16]);  
  }
}

difference() {
  union() {
    cube([fx,fy,2],false);

    translate([26.5,13.6,0])
    translate([-3/2,-3/2,0])
    cube([cx+3,cy+3,cinsert],false);


    translate([26.5,13.6+20+21.9,0])
    translate([-3/2,-3/2,0])
    cube([cx+3,cy+3,cinsert],false);
  }

  translate([26.5,13.6,-1])
  cube([cx,cy,cinsert+2],false);

  translate([26.5,13.6+20+21.9,-1])
  cube([cx,cy,cinsert+2],false);

  // cut out clearance for bolts and stuff
  translate([128,0,38])
  rotate([0,45,0])
  translate([-10,0,0])
  cube([40,fy,20]);

  // cut out to clear inner pcb pins
  translate([30,30,cinsert-3])
  cube([cx,30,3]);

  // cut out for insertion protection switch
  translate([70,33.5,5])
  SwitchCutout();

  translate([70,75,5])
  SwitchCutout();
}

// support for top slot insertion protect switch
translate([70-1,35,5-1.5])
SwitchHold();

translate([70-1,77,5-1.5])
SwitchHold();

// pcboard catch - top left
translate([30,9.5,0])
cube([10,3,cinsert+3]);

// pcboard catch - top right
translate([110,9.5,0])
cube([10,3,cinsert+3]);

// pcboard catch - bottom left
translate([30,76,0])
cube([10,6,cinsert]);
translate([30,79,0])
cube([10,3,cinsert+3]);

// pcboard catch - bottom right
translate([110,76,0])
cube([10,6,cinsert]);
translate([110,79,0])
cube([10,3,cinsert+3]);

// support between slots
translate([65,35,0])
cube([1,20,15]);

// side mounts
translate([4,2,2])
SideMount();

translate([4,86-2,2])
scale([1,-1,1])
SideMount();

translate([fx-4,2,2])
scale([-1,1,1])
SideMount();

translate([fx-4,86-2,2])
scale([-1,-1,1])
SideMount();

translate([75,9,2])
linear_extrude(1)
scale([0.7,0.7,1])
rotate([0,0,180])
text("TOP");
